from System.Collections.Generic import List
from System import Byte, Int32
import sys
#
# Set this to the exact name of your pick script .. capital matters
# and it has to be in your list of scripts on UI
#
BagOfHolding = 0x4029D93F
AtlasGumpId = 878763590
RecallAction = 4
SacredJourneyAction = 7
MovementAction = SacredJourneyAction
MaxWeight = 520
ShovelID = 0x0F39
WaitForTarget = 5000
WaitAfterMining = 2000
WaitAfterPickAxe = 4000

#
# First keep track of position in book 
#
RuneBooks = [0x40152333, ]
#    
#
#
# Next keep track of position in book. At end of a book we'll set next book 
#
RuneOrder = range(100, 148, 1)
#
# First set which rune to use to 0 in case its not stored yet
# if its stored we'll use the stored value 
RuneIndexName = "Mining Rune Order"
RuneIndex = 0
RuneBookIndexName = "Mining RuneBook Order"
RuneBookIndex = 0
# 

def StoreNextRuneInfo(runeIndex): 
    stop = False
    #Misc.SendMessage("STORE before next: {}".format(runeIndex))  
    # Now store whatever it is +1 so next time we'll do the next one
    # Skip the empty places
    new_rune_index = runeIndex+1
    bookSlotName = Gumps.LastGumpGetLine(RuneBookFirstNameIndex()+new_rune_index).lower()
    #Misc.SendMessage("STORE Name: {}".format(bookSlotName.strip()))
    # check if the new index is past the end, then start back at 0
    if new_rune_index >= len(RuneOrder) or bookSlotName == "empty":
        new_rune_index = 0
        # and move to the next book
        new_book_index = RuneBookIndex+1
        # check if the new book index is past the end, then start back at 0
        # Maybe want to stop here, because probably chests have not respawned
        if new_book_index >= len(RuneBooks):
            new_book_index = 0
            Misc.SetSharedValue(RuneBookIndexName, 0)
            stop = True  # stop after this one
    # Now store the next rune so that next time we come here we start with the new one
    Misc.SetSharedValue(RuneIndexName, new_rune_index)
    #Misc.SendMessage("STORE new index: {}".format(new_rune_index))
    return stop
#
#
# A function I'll need later to check if runbook entry is Empty
#
def RuneBookFirstNameIndex():    
    gumpList = Gumps.LastGumpGetLineList()
    #Misc.SendMessage(len(gumpList))
    textParts = ["charges: ~1_val~ / ~2_val~", "Rename book", "Set default", "Drop rune", 
    "Recall (Spell)", "Recall (Charge)", "Gate Travel", "Sacred Journey" ]
    index = 0
    #Misc.SendMessage("text: {}".format(gumpList[index]), 7)
    while gumpList[index].strip() in textParts:
        #Misc.SendMessage("text: {}".format(gumpList[index]), 7)
        index = index + 1
        # now index should be at the charges numbers so skip 1 more
    #Misc.SendMessage("Starts at: {}".format(index))
    return index
#
def GetToRightPage(index):
    # 118
    relativeIndex = index 
    page = index / 16 
    for i in range(page):
        NextPage = 1150
        Gumps.SendAction(AtlasGumpId, NextPage)
        Gumps.WaitForGump(AtlasGumpId, 2000)

def RecallTo(index):
    Misc.SendMessage("Index: {} RuneIndex: {}".format(index, RuneOrder[index])) # 118
    Gumps.ResetGump()
    Items.UseItem(RuneBooks[RuneBookIndex])
    Gumps.WaitForGump(AtlasGumpId, 2000)
    GetToRightPage(index) 
    #    
    Gumps.SendAction(AtlasGumpId, RuneOrder[index])
    Gumps.WaitForGump(AtlasGumpId, 2000) 
    Gumps.SendAction(AtlasGumpId, MovementAction)
    Misc.Pause(2000)
#        
def CheckWeight():
    if Player.Weight < (Player.MaxWeight*.9) and Player.Weight < MaxWeight:
        return 0
    # 
    ORE = [0x19B7, 0x19B8, 0x19B9, 0x19Ba, 0x1779, 0x11EA, 0x0F81, ]
    for ore in Player.Backpack.Contains:
        if ore.ItemID in ORE:
            Items.Move(ore, BagOfHolding, 0)
            Misc.Pause(1000)
    if Player.Weight < (Player.MaxWeight*.9) and Player.Weight < MaxWeight:
        return 0
    
    Player.HeadMessage(55, "Even after move I am over weight")
    Misc.SendMessage("Even after move I am over weight")
    Misc.SendMessage("STOPPING")
    sys.exit(99)
#
def CheckUseGarg():
    return False
#
MotionMap = {
             "North": (0, -1), 
             "Right": (+1, -1),
             "East": (+1, 0),
             "Down": (+1, +1),
             "South": (0, +1),
             "Left": (-1, +1),
             "West": (-1, 0),
             "Up": (-1, -1),
             } 
RotateMap = {
             "North": "Right", 
             "Right": "East",
             "East": "Down",
             "Down": "South",
             "South": "Left",
             "Left": "West",
             "West": "Up",
             "Up": "North"
             } 
#
CaveTiles = [ 0xae, 0x5, 0x3, 0xc1, 0xc2, 0xc3, 0xbd, 0x0016, 0x0017, 0x0018, 0x0019, 0x245, 0x246, 0x247, 0x248, 0x249, 0x22b, 0x22c, 0x22d, 0x22e, 0x22f ]    
SoilTiles = [0x73, 0x74, 0x75, 0x76,  0x77, 0x78]
#             
def FaceMountain():  
    x_delta, y_delta = MotionMap[Player.Direction]
    x = Player.Position.X + x_delta
    y = Player.Position.Y + y_delta
    land_id = Statics.GetLandID(x, y, Player.Map)
    impassible = Statics.GetLandFlag(land_id, "Impassable")
    Misc.SendMessage("X: {} Y: {} LandID: 0x{:x} ImPassable: {}".format(x, y, land_id, impassible))
    if impassible:
        return
    startDirection = Player.Direction
    checkDirection = RotateMap[Player.Direction]
    while checkDirection != startDirection:
        Misc.SendMessage("Face: {}".format(checkDirection))
        #Player.Walk(RotateMap[Player.Direction])
        x_delta, y_delta = MotionMap[checkDirection]
        x = Player.Position.X + x_delta
        y = Player.Position.Y + y_delta
        land_id = Statics.GetLandID(x, y, Player.Map)
        impassible = Statics.GetLandFlag(land_id, "Impassable")
        Misc.SendMessage("X: {} Y: {} LandID: 0x{:x} ImPassable: {}".format(x, y, land_id, impassible))
        if impassible:
            Player.Walk(checkDirection)
            return
        checkDirection = RotateMap[checkDirection]    
#    
def MineSpot():
    FaceMountain()
    x_delta, y_delta = MotionMap[Player.Direction]
    x = Player.Position.X + x_delta
    y = Player.Position.Y + y_delta
    xStart = Player.Position.X
    yStart = Player.Position.Y
    #
    land_id = Statics.GetLandID(x, y, Player.Map)
    Misc.SendMessage("X: {} Y: {} LandID: 0x{:x} ImPassable: {}".format(x, y, land_id, Statics.GetLandFlag(land_id, "Impassable")))
    if Statics.GetLandFlag(land_id, "Impassable") or land_id in CaveTiles or land_id in SoilTiles:
        Journal.Clear()
        while True:
            if Player.Position.X != xStart:
                return
            if Player.Position.Y != yStart:
                return    
            if Journal.Search('There is no'):
                Player.HeadMessage(5, "DONE DONE")
                break
            if Journal.Search('no sand'):
                Player.HeadMessage(5, "DONE DONE")                
                break
            if Journal.Search('Target cannot be seen'):
                break
            if Journal.Search('You can\'t mine'):
                break
            tileinfo = Statics.GetStaticsLandInfo(x, y, Player.Map)
            if CheckUseGarg():
                if Items.BackpackCount(0x0E86, 0x076c) > 0:
                    Items.UseItemByID(0x0E86, 0x076c)
                elif Items.BackpackCount(0x0E85, 0x076c) > 0:    
                    Items.UseItemByID(0x0E85, 0x076c)
                else:
                    Player.HeadMessage(1, "NO GARG PICKS")
                    if Items.BackpackCount(0x0E86, 0) > 0:
                        Items.UseItemByID(0x0E86, -1)    
                    else:    
                        Items.UseItemByID(ShovelID, -1)    
                Mobiles.Message (Player.Serial, 4, "Using Garg Axe")
            else:    
                if Items.BackpackCount(0x0E86, 0) > 0:
                    Items.UseItemByID(0x0E86, -1)    
                else:    
                    Items.UseItemByID(ShovelID, -1) 
            Target.WaitForTarget(WaitForTarget, False)                    
            tiles = Statics.GetStaticsTileInfo(x, y, Player.Map)
            #Misc.SendMessage("LandID: 0x{:x} #tiles{}".format(tileinfo.StaticID, len(tiles)), 5)
            if tileinfo.StaticID in CaveTiles and len(tiles) > 0:
                #Misc.SendMessage("StaticID: 0x{:x} #tiles{}".format(tiles[0].StaticID, len(tiles)), 5)
                Target.TargetExecute(x, y, tiles[0].StaticZ, tiles[0].StaticID)
            else:
                Target.TargetExecuteRelative(Player.Serial, 1)
            Misc.Pause(WaitAfterMining)
            on_me_filter = Mobiles.Filter()
            on_me_filter.Enabled = True
            on_me_filter.RangeMin = -1
            on_me_filter.RangeMax = 2
            on_me_filter.Bodies = List[int] ( [ 0x006F ] )
            on_me_filter.Notorieties = List[Byte](bytes([3,4,5,6]))
            up_close_enemies = Mobiles.ApplyFilter(on_me_filter)
            if len(up_close_enemies) > 0:
                Player.HeadMessage(2, "STOPPING FOR AGRO")
                Stop()
            if Player.WarMode == True:
                Stop()    
            if Target.HasTarget(): 
                Target.Cancel()                    
            CheckWeight()    
#
#
# Now finally everything is set. 
#
#
# RuneBookIndex is set to the current book to use
# RuneIndex is set to which rune in that book to use
stop = False
while not stop:
    if Misc.CheckSharedValue(RuneBookIndexName):
        RuneBookIndex = Misc.ReadSharedValue(RuneBookIndexName)    
    if Misc.CheckSharedValue(RuneIndexName):
        RuneIndex = Misc.ReadSharedValue(RuneIndexName)    
    
    Gumps.ResetGump()
    Items.UseItem(RuneBooks[RuneBookIndex])
    Gumps.WaitForGump(AtlasGumpId, 2000)
    stop = StoreNextRuneInfo(RuneIndex)
    bookSlotName = Gumps.LastGumpGetLine(RuneBookFirstNameIndex()+RuneIndex)
    Misc.SendMessage(bookSlotName.strip().lower()) 
    if bookSlotName.strip().lower() == "empty":
        Misc.SendMessage("Skipping recall slot {} because it is empty".format(RuneIndex))
    else:
        RecallTo(RuneIndex)
        MineSpot()
   